/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PATV                                                     */
/* Tabela : PRINATIV                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PATV' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_PATV
GO

CREATE TRIGGER DTULTATU_PATV
ON PRINATIV
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'PRINATIV', null, 'CDPRINATIV='+ CDPRINATIV+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PRINATIV
      SET DTULTATUPATV = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(PRINATIV.CDPRINATIV,0) = ISNULL(INSERTED.CDPRINATIV,0));
   END;
END;
GO

